﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Telerik.WinControls.UI;

namespace _554356BalanceColumnSummaryItem
{
    public partial class RadForm1 : Telerik.WinControls.UI.RadForm
    {
        public RadForm1()
        {
            InitializeComponent();

            this.radGridView1.Columns.Add(new GridViewDecimalColumn("Id"));
            this.radGridView1.Columns.Add("Type");
            this.radGridView1.Columns.Add(new GridViewDecimalColumn("Credit"));
            this.radGridView1.Columns.Add(new GridViewDecimalColumn("Debit"));
            this.radGridView1.Columns.Add(new GridViewDecimalColumn("Balance"));
            this.radGridView1.AutoSizeColumnsMode = Telerik.WinControls.UI.GridViewAutoSizeColumnsMode.Fill;
            for (int i = 0; i < 10; i++)
            {
                this.radGridView1.Rows.Add(i, "Type" + i % 2, i * 2.25, i, i);
            }
            
            GridViewSummaryRowItem summaryRowItem = new GridViewSummaryRowItem();
            GridViewSummaryItem summaryItem = new GridViewSummaryItem();
            summaryItem.Name = "Credit";
            summaryItem.Aggregate = GridAggregateFunction.Sum;
            GridViewSummaryItem summaryItem2 = new GridViewSummaryItem();
            summaryItem2.Name = "Debit";
            summaryItem2.Aggregate = GridAggregateFunction.Sum;
          
            CustomSummaryItem summaryItem3 = new CustomSummaryItem();
            summaryItem3.Name = "Balance";
            summaryItem3.Aggregate = GridAggregateFunction.Sum;
            summaryRowItem.Add(summaryItem);
            summaryRowItem.Add(summaryItem2);
            summaryRowItem.Add(summaryItem3);

            this.radGridView1.SummaryRowsBottom.Add(summaryRowItem);
        }

        public class CustomSummaryItem : GridViewSummaryItem
        {
            public CustomSummaryItem() : base()
            {
            }

            public override object Evaluate(IHierarchicalRow row)
            {
                decimal credit = 0;
                decimal debit = 0;
                foreach (GridViewRowInfo childRow in row.ChildRows)
                {
                    credit += (decimal)childRow.Cells["Credit"].Value;
                    debit += (decimal)childRow.Cells["Debit"].Value;
                }
                return credit - debit;
            }
        }
    }
}